#include "util.h"
#include "types.h"
#include "ArchTokens.h"

/* List of token pairs. Order doesn't need to match the enumeration order in
 * ArchTokens.h but it would be a good idea */

/* ArchBaseTokenList is for command tokens. We will track how many times 
 * each of these things exist in a file */
const struct s_TokenPair ArchBaseTokenList[] = {
	{"clb_grid", AT_CLB_GRID}, 
	{"io_rat", AT_IO_RAT}, 
	{"chan_width_io", AT_CHAN_WIDTH_IO}, 
	{"chan_width_x", AT_CHAN_WIDTH_X}, 
	{"chan_width_y", AT_CHAN_WIDTH_Y}, 	
	{"outpin", AT_OUTPIN},	
	{"inpin", AT_INPIN}, 
	{"subblocks_per_clb", AT_SUBBLOCKS_PER_CLB}, 
	{"subblock_lut_size", AT_SUBBLOCK_LUT_SIZE}, 
	{"Fc_type", AT_FC_TYPE}, 
	{"Fc_output", AT_FC_OUTPUT},
	{"Fc_input", AT_FC_INPUT}, 
	{"Fc_pad", AT_FC_PAD}, 
	{"Fs", AT_FS}, 
	{"switch_block_type", AT_SWITCH_BLOCK_TYPE}, 
	{"segment", AT_SEGMENT}, 
	{"switch", AT_SWITCH}, 
	{"R_minW_nmos", AT_R_MINW_NMOS}, 
	{"R_minW_pmos", AT_R_MINW_PMOS}, 
	{"C_ipin_cblock", AT_C_IPIN_SBLOCK},
	{"T_ipin_cblock", AT_T_IPIN_CBLOCK}, 
	{"T_sblk_opin_to_sblk_ipin", AT_T_SBLK_OPIN_TO_SBLK_IPIN}, 
	{"T_clb_ipin_to_sblk_ipin", AT_T_CLB_IPIN_TO_SBLK_IPIN}, 
	{"T_sblk_opin_to_clb_opin", AT_T_SBLK_OPIN_TO_CLB_OPIN}, 	
	{"T_ipad", AT_T_IPAD}, 
	{"T_opad", AT_T_OPAD}, 
	{"T_subblock", AT_T_SUBBLOCK}, 
	{"ipin_mux_trans_size", AT_IPIN_MUX_TRANS_SIZE},
	{"clb_area", AT_CLB_AREA},
	{NULL, AT_BASE_UNKNOWN} /* End of list marker */
}; 

/* This is the list for all tokens that aren't command tokens */
const struct s_TokenPair ArchArgTokenList[] = {
	{"auto", AT_AUTO}, 
	{"uniform", AT_UNIFORM}, 
	{"delta", AT_DELTA}, 	
	{"gaussian", AT_GAUSSIAN},
	{"pulse", AT_PULSE}, 
	{"class:", AT_CLASS},
	{"global", AT_GLOBAL},
	{"left", AT_LEFT}, 
	{"top", AT_TOP},
	{"right", AT_RIGHT}, 
	{"bottom", AT_BOTTOM}, 
	{"fractional", AT_FRACTIONAL}, 
	{"absolute", AT_ABSOLUTE}, 
	{"subset", AT_SUBSET}, 
	{"wilton", AT_WILTON}, 
	{"universal", AT_UNIVERSAL}, 
	{"full", AT_FULL}, 
	{"frequency:", AT_FREQUENCY}, 
	{"length:", AT_LENGTH},
	{"longline", AT_LONGLINE}, 
	{"wire_switch:", AT_WIRE_SWITCH},
	{"opin_switch:", AT_OPIN_SWITCH},
	{"Frac_cb:", AT_FRAC_CB}, 
	{"Frac_sb:", AT_FRAC_SB}, 
	{"Rmetal:", AT_RMETAL}, 
	{"Cmetal:", AT_CMETAL},
	{"directionality:", AT_DIRECTIONALITY}, 
	{"uni_directional", AT_UNI_DIRECTIONAL},
	{"bi_directional", AT_BI_DIRECTIONAL},
	{"buffered:", AT_BUFFERED},
	{"yes", AT_YES},
	{"no", AT_NO},
	{"R:", AT_R}, 
	{"Cin:", AT_CIN}, 
	{"Cout:", AT_COUT},	
	{"Tdel:", AT_TDEL}, 
	{"T_comb:", AT_T_COMB},
	{"T_seq_in:", AT_T_SEQ_IN}, 
	{"T_seq_out:", AT_T_SEQ_OUT},
	{"buf_size:", AT_BUF_SIZE},
	{"mux_trans_size:", AT_MUX_TRANS_SIZE},
	{NULL, AT_ARG_UNKNOWN} /* End of list marker */
};

