struct s_pin {
	boolean IsGlobal;
	enum e_side Side;
	enum e_pin_type Type;
	int Class;
	struct s_pin *Next;
};

struct s_clb_grid {
	boolean IsAuto;
	float Aspect;
	int W;
	int H;
};


/* Defines for a bitfield */
#define S_SEG_FREQUENCY (1 << 0)
#define S_SEG_LENGTH (1 << 1)
#define S_SEG_WIRE_SWITCH (1 << 2)
#define S_SEG_OPIN_SWITCH (1 << 3)
#define S_SEG_FRAC_CB (1 << 4)
#define S_SEG_FRAC_SB (1 << 5)
#define S_SEG_RMETAL (1 << 6)
#define S_SEG_CMETAL (1 << 7)
#define S_SEG_DIRECTIONALITY (1 << 8)
#define S_SEG_ALL_TIMING (S_SEG_RMETAL | S_SEG_CMETAL)

struct s_seg {
	float Freq;
	int Len;
	boolean IsLong;
	int WireSwitch;
	int OPinSwitch;
	float Frac_cb;
	float Frac_sb;
	float Rmetal;
	float Cmetal;
	enum e_directionality Directionality;
	bitfield IsSet;
	struct s_seg *Next;
};


#define S_SWITCH_BUFFERED (1 << 0)
#define S_SWITCH_R (1 << 1)
#define S_SWITCH_CIN (1 << 2)
#define S_SWITCH_COUT (1 << 3)
#define S_SWITCH_TDEL (1 << 4)
#define S_SWITCH_ALL_TIMING (S_SWITCH_R | S_SWITCH_CIN | \
                             S_SWITCH_COUT | S_SWITCH_TDEL)
#define S_SWITCH_BUFSIZE (1 << 5)
#define S_SWITCH_MUXTRANSSIZE (1 << 6)

struct s_switch {
	int Index;
	boolean Buffered; 
	float R; 
	float Cin; 
	float Cout; 
	float Tdel;
	float BufSize;
	float MuxTransSize;
	bitfield IsSet;
	struct s_switch *Next;
};


#define S_TSUBBLOCK_T_COMB (1 << 0)
#define S_TSUBBLOCK_T_SEQ_IN (1 << 1)
#define S_TSUBBLOCK_T_SEQ_OUT (1 << 2)

struct s_tsubblock {
	float T_comb;
	float T_seq_in;
	float T_seq_out;
	bitfield IsSet;
	struct s_tsubblock *Next;
};


typedef struct s_arch t_arch;
struct s_arch {
	int IO_Ratio;
	t_chan_width_dist Chans;
	struct s_pin *Pins;
	int N; /* Cluster size */
	int K; /* LUT size */
	float Fc_Out;
	boolean Fc_out_full_flex;
	float Fc_In;
	float Fc_Pad;
	enum e_Fc_type Fc_Type;
	enum e_switch_block_type SBType;
	float R_minW_nmos;
	float R_minW_pmos;
	int Fs;
	float C_ipin_cblock;
	float T_ipin_cblock;
	float T_sblk_opin_to_sblk_ipin;
	float T_clb_ipin_to_sblk_ipin;
	float T_sblk_opin_to_clb_opin;
	float T_ipad;
	float T_opad;	
	float clb_area;
	float ipin_mux_trans_size;
	struct s_clb_grid clb_grid;	
	struct s_seg *Segments;
	struct s_switch *Switches;
	struct s_tsubblock *TSubblocks;
	int Count[AT_BASE_UNKNOWN];
};

void ReadArch(INOUT char *FileName,
			  OUT t_arch *Arch);
